#ifndef _DECL_RefineLB_H_
#define _DECL_RefineLB_H_
#include "charm++.h"
#include "CentralLB.decl.h"

/* DECLS: group RefineLB: CentralLB{
void RefineLB(void);
};
 */
class RefineLB;
class CProxy_RefineLB:  public virtual _CK_GID, public CProxy_CentralLB{
  public:
    static int __idx;
    static void __register(const char *s, size_t size);
    CProxy_RefineLB(CkGroupID _gid) :CProxy_CentralLB(_gid){ _ck_gid = _gid; _setChare(0); }
    CProxy_RefineLB(CkChareID __cid) :CProxy_CentralLB(__cid){ ckSetChareId(__cid); }
    CkChareID ckGetChareId(void) { return _ck_cid; }
    void ckSetChareId(CkChareID __cid){_CHECK_CID(__cid,__idx);_ck_cid=__cid;_setChare(1);}
    CkGroupID ckGetGroupId(void) { return _ck_gid; }
    void ckSetGroupId(CkGroupID _gid){_ck_gid=_gid;_setChare(0);}
    RefineLB* ckLocalBranch(void) {
      return (RefineLB *) CkLocalBranch(_ck_gid);
    }
    static RefineLB* ckLocalBranch(CkGroupID gID) {
      return (RefineLB *) CkLocalBranch(gID);
    }
/* DECLS: void RefineLB(void);
 */
    static CkGroupID ckNew(void);
    static CkGroupID ckNewSync(void);
    CProxy_RefineLB(int retEP, CkChareID *cid);
    CProxy_RefineLB(void);
    static int  __idx_RefineLB_void;
    static int  ckIdx_RefineLB(void) { return __idx_RefineLB_void; }
    static void _call_RefineLB_void(void* msg, RefineLB* obj);
};

extern void _registerRefineLB(void);
#endif
